Index: typo3/sysext/rtehtmlarea/htmlarea/plugins/TableOperations/table-operations.js
===================================================================
--- typo3/sysext/rtehtmlarea/htmlarea/plugins/TableOperations/table-operations.js	(révision 6908)
+++ typo3/sysext/rtehtmlarea/htmlarea/plugins/TableOperations/table-operations.js	(copie de travail)
@@ -3,7 +3,7 @@
 *
 *  (c) 2002 interactivetools.com, inc. Authored by Mihai Bazon, sponsored by http://www.bloki.com.
 *  (c) 2005 Xinha, http://xinha.gogo.co.nz/ for the original toggle borders function.
-*  (c) 2004-2009 Stanislas Rolland <typo3(arobas)sjbr.ca>
+*  (c) 2004-2010 Stanislas Rolland <typo3(arobas)sjbr.ca>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
@@ -66,11 +66,9 @@
 				this.defaultClass = this.buttonsConfiguration.table.properties.tableClass.defaultValue;
 			}
 		}
-		
 		if (this.buttonsConfiguration.blockstyle) {
 			this.tags = this.editorConfiguration.buttons.blockstyle.tags;
 		}
-		
 		this.tableParts = ["tfoot", "thead", "tbody"];
 		this.convertAlignment = { "not set" : "none", "left" : "JustifyLeft", "center" : "JustifyCenter", "right" : "JustifyRight", "justify" : "JustifyFull" };
 		
@@ -78,7 +76,7 @@
 		 * Registering plugin "About" information
 		 */
 		var pluginInformation = {
-			version		: "4.2",
+			version		: "5.0",
 			developer	: "Mihai Bazon & Stanislas Rolland",
 			developerUrl	: "http://www.sjbr.ca/",
 			copyrightOwner	: "Mihai Bazon & Stanislas Rolland",
@@ -114,7 +112,7 @@
 	/*
 	 * The list of buttons added by this plugin
 	 */
-	buttonList : [
+	buttonList: [
 		["InsertTable",		null,				"table", true],
 		["toggle-borders",	null, 				"toggleborders", false],
 		["table-prop",		"table",			"tableproperties", true],
@@ -136,222 +134,430 @@
 		["cell-merge",		"tr",				"cellmerge", false],
 		["cell-split",		"td,th[colSpan!=1,rowSpan!=1]",	"cellsplit", false]
 	],
-	
 	/*
+	 * Sets of default configuration values for dialogue form fields
+	 */
+	configDefaults: {
+		combo: {
+			editable: true,
+			typeAhead: true,
+			triggerAction: 'all',
+			forceSelection: true,
+			mode: 'local',
+			valueField: 'value',
+			displayField: 'text',
+			helpIcon: true,
+			tpl: '<tpl for="."><div ext:qtip="{value}" style="text-align:left;font-size:11px;" class="x-combo-list-item">{text}</div></tpl>'
+		}
+	},
+	/*
 	 * Retrieve the closest element having the specified nodeName in the list of
 	 * ancestors of the current selection/caret.
 	 */
-	getClosest : function (nodeName) {
-		var editor = this.editor;
-		var ancestors = editor.getAllAncestors();
-		var ret = null;
-		nodeName = ("" + nodeName).toLowerCase();
-		for (var i=0; i < ancestors.length; ++i) {
-			var el = ancestors[i];
-			if (el.nodeName.toLowerCase() == nodeName) {
-				ret = el;
-				break;
+	getClosest: function (nodeName) {
+		var ancestors = this.editor.getAllAncestors();
+		var element = null;
+		Ext.each(ancestors, function (ancestor) {
+			if (ancestor.nodeName.toLowerCase() === nodeName) {
+				element = ancestor;
+				return false;
 			}
+		});
+		return element;
+	},
+	/*
+	 * Get the integer value of a string or '' if the string is not a number
+	 *
+	 * @param	string		string: the input value
+	 *
+	 * @return	mixed		a number or ''
+	 */
+	getLength: function (string) {
+		var length = parseInt(string);
+		if (isNaN(length)) {
+			length = '';
 		}
-		return ret;
+		return length;
 	},
-	
 	/*
-	 * Open the table properties dialogue
+	 * Open properties dialogue
+	 *
+	 * @param	string		type: 'cell', 'column', 'row' or 'table'
+	 * @param	string		buttonId: the buttonId of the button that was pressed
+	 *
+	 * @return 	void
 	 */
-	dialogTableProperties : function (buttonId) {
-		var tablePropertiesInitFunctRef = this.makeFunctionReference("tablePropertiesInit");
-		var insert = (buttonId === "InsertTable");
-		var arguments = {
-			buttonId	: buttonId,
-			title 		: (insert ? "Insert Table" : "Table Properties"),
-			initialize	: tablePropertiesInitFunctRef,
-			element		: (insert ? null : this.getClosest("table"))
-		};
-		var dimensions = {
-			width	: 860,
-			height	: 620
-		};
-		this.dialog = this.openDialog((insert ? "InsertTable" : "TO-table-prop"), "", "tablePropertiesUpdate", arguments, dimensions);
+	openPropertiesDialogue: function (type, buttonId) {
+			// Retrieve the element being edited and set configuration according to type
+		switch (type) {
+			case 'cell':
+			case 'column':
+				var element = this.getClosest('td');
+				if (!element) {
+					var element = this.getClosest('th');
+				}
+				this.properties = this.buttonsConfiguration.cellproperties.properties;
+				var title = (type == 'column') ? 'Column Properties' : 'Cell Properties';
+				break;
+			case 'row':
+				var element = this.getClosest('tr');
+				this.properties = this.buttonsConfiguration.rowproperties.properties;
+				var title = 'Row Properties';
+				break;
+			case 'table':
+				var insert = (buttonId === 'InsertTable');
+				var element = insert ? null : this.getClosest('table');
+				this.properties = this.buttonsConfiguration.table.properties;
+				var title = insert ? 'Insert Table' : 'Table Properties';
+				break;
+		}
+		var propertySet = element ? type + 'properties' : 'table';
+		this.removedFieldsets = (this.buttonsConfiguration[propertySet] && this.buttonsConfiguration[propertySet].removeFieldsets) ? this.buttonsConfiguration[propertySet].removeFieldsets : '';
+		this.removedProperties = (this.properties && this.properties.removed) ? this.properties.removed : '';
+			// Open the dialogue window
+		this.openDialogue(
+			title,
+			{
+				element: element,
+				cell: type == 'cell',
+				column: type == 'column',
+				buttonId: buttonId
+			},
+			type == 'table' ? this.getWindowDimensions({ width: 600}, buttonId) : this.getWindowDimensions({ width: 600}, buttonId),
+			this.buildTabItemsConfig(element, type, buttonId),
+			type == 'table' ? this.tablePropertiesUpdate : this.rowCellPropertiesUpdate
+		);
 	},
-	
 	/*
-	 * Initialize the table insertion or table properties dialog
+	 * Build the dialogue tab items config
+	 *
+	 * @param	object		element: the element being edited, if any
+	 * @param	string		type: 'cell', 'column', 'row' or 'table'
+	 * @param	string		buttonId: the buttonId of the button that was pressed
+	 *
+	 * @return	object		the tab items configuration
 	 */
-	tablePropertiesInit : function(dialog) {
-		var doc = dialog.document;
-		var content = dialog.content;
-		var table = dialog.arguments.element;
-		this.removedFieldsets = this.buttonsConfiguration[table?"tableproperties":"table"].removeFieldsets ? this.buttonsConfiguration[table?"tableproperties":"table"].removeFieldsets : "";
-		this.properties = this.buttonsConfiguration.table.properties;
-		this.removedProperties = (this.properties && this.properties.removed) ? this.properties.removed : "";
-		TableOperations.buildTitle(doc, content, dialog.arguments.title);
-		TableOperations.insertSpace(doc, content);
-		if (this.removedFieldsets.indexOf("description") == -1) {
-			TableOperations.buildDescriptionFieldset(doc, table, content, "floating");
+	buildTabItemsConfig: function (element, type, buttonId) {
+		var tabItems = [];
+		var generalTabItems = [];
+		switch (type) {
+			case 'table':
+				if (this.removedFieldsets.indexOf('description') === -1) {
+					this.addConfigElement(this.buildDescriptionFieldsetConfig(element), generalTabItems);
+				}
+				if (Ext.isEmpty(element) || this.removedProperties.indexOf('headers') === -1) {
+					this.addConfigElement(this.buildSizeAndHeadersFieldsetConfig(element), generalTabItems);
+				}
+				break;
+			case 'column':
+				if (this.removedFieldsets.indexOf('columntype') == -1) {
+					this.addConfigElement(this.buildCellTypeFieldsetConfig(element, true), generalTabItems);
+				}
+				break;
+			case 'cell':
+				if (this.removedFieldsets.indexOf('celltype') == -1) {
+					this.addConfigElement(this.buildCellTypeFieldsetConfig(element, false), generalTabItems);
+				}
+				break;
+			case 'row':
+				if (this.removedFieldsets.indexOf('rowgroup') == -1) {
+					this.addConfigElement(this.buildRowGroupFieldsetConfig(element), generalTabItems);
+				}
+				break;
 		}
-		if (this.removedFieldsets.indexOf("spacing") == -1) TableOperations.buildSpacingFieldset(doc, table, content);
-		TableOperations.insertSpace(doc, content);
-		this.buildSizeAndHeadersFieldset(doc, table, content, "floating");
-		if (this.removedFieldsets.indexOf("style") == -1 && dialog.editor.config.customSelects.BlockStyle) {
-			var blockStyle = dialog.editor.plugins.BlockStyle.instance;
+		if (this.removedFieldsets.indexOf('style') == -1 && this.getButton('BlockStyle')) {
+			var blockStyle = this.getPluginInstance('BlockStyle');
 			if (blockStyle && blockStyle.cssLoaded) {
-				this.buildStylingFieldset(doc, table, content, null, dialog.arguments.buttonId);
-				TableOperations.insertSpace(doc, content);
+				this.addConfigElement(this.buildStylingFieldsetConfig(element, buttonId), generalTabItems);
 			}
 		}
-		this.buildLanguageFieldset(doc, table, content, "floating");
-		if (this.removedFieldsets.indexOf("layout") == -1) this.buildLayoutFieldset(doc, table, content, "floating");
-		if (this.removedFieldsets.indexOf("alignment") == -1) this.buildAlignmentFieldset(doc, table, content);
-		TableOperations.insertSpace(doc, content);
-		if (this.removedFieldsets.indexOf("borders") == -1) this.buildBordersFieldset(dialog.dialogWindow, doc, dialog.editor, table, content);
-		if (this.removedFieldsets.indexOf("color") == -1) TableOperations.buildColorsFieldset(dialog.dialogWindow, doc, dialog.editor, table, content);
-		dialog.addButtons("ok", "cancel");
+		if (!Ext.isEmpty(generalTabItems)) {
+			tabItems.push({
+				title: this.localize('General'),
+				items: generalTabItems
+			});
+		}
+		var layoutTabItems = [];
+		if (type === 'table' && this.removedFieldsets.indexOf('spacing') === -1) {
+			this.addConfigElement(this.buildSpacingFieldsetConfig(element), layoutTabItems);
+		}
+		if (this.removedFieldsets.indexOf('layout') == -1) {
+			this.addConfigElement(this.buildLayoutFieldsetConfig(element), layoutTabItems);
+		}
+		if (!Ext.isEmpty(layoutTabItems)) {
+			tabItems.push({
+				title: this.localize('Layout'),
+				items: layoutTabItems
+			});
+		}
+		var languageTabItems = [];
+		if (this.removedFieldsets.indexOf('language') === -1 && (this.removedProperties.indexOf('language') === -1 || this.removedProperties.indexOf('direction') === -1) && (this.getButton('Language') || this.getButton('LeftToRight') || this.getButton('RightToLeft'))) {
+			this.addConfigElement(this.buildLanguageFieldsetConfig(element), languageTabItems);
+		}
+		if (!Ext.isEmpty(languageTabItems)) {
+			tabItems.push({
+				title: this.localize('Language'),
+				items: languageTabItems
+			});
+		}
+		var alignmentAndBordersTabItems = [];
+		if (this.removedFieldsets.indexOf('alignment') === -1) {
+			this.addConfigElement(this.buildAlignmentFieldsetConfig(element), alignmentAndBordersTabItems);
+		}
+		if (this.removedFieldsets.indexOf('borders') === -1) {
+			this.addConfigElement(this.buildBordersFieldsetConfig(element), alignmentAndBordersTabItems);
+		}
+		if (!Ext.isEmpty(alignmentAndBordersTabItems)) {
+			tabItems.push({
+				title: this.localize('Alignment') + '/' + this.localize('Border'),
+				items: alignmentAndBordersTabItems
+			});
+		}
+		var colorTabItems = [];
+		if (this.removedFieldsets.indexOf('color') === -1) {
+			this.addConfigElement(this.buildColorsFieldsetConfig(element), colorTabItems);
+		}
+		if (!Ext.isEmpty(colorTabItems)) {
+			tabItems.push({
+				title: this.localize('Background and colors'),
+				items: colorTabItems
+			});
+		}
+		return tabItems;
 	},
-	
 	/*
+	 * Open the dialogue window
+	 *
+	 * @param	string		title: the window title
+	 * @param	object		arguments: some arguments for the handler
+	 * @param	integer		dimensions: the opening width of the window
+	 * @param	object		tabItems: the configuration of the tabbed panel
+	 * @param	function	handler: handler when the OK button if clicked
+	 *
+	 * @return	void
+	 */
+	openDialogue: function (title, arguments, dimensions, tabItems, handler) {
+		if (this.dialog) {
+			this.dialog.close();
+		}
+		this.dialog = new Ext.Window({
+			title: this.localize(title),
+			arguments: arguments,
+			cls: 'htmlarea-window',
+				// As of ExtJS 3.1, JS error with IE when the window is resizable
+			resizable: !Ext.isIE,
+			border: false,
+			width: dimensions.width,
+			height: 'auto',
+			iconCls: arguments.buttonId,
+			listeners: {
+				close: {
+					fn: this.onClose,
+					scope: this
+				}
+			},
+			items: {
+				xtype: 'tabpanel',
+				activeTab: 0,
+				defaults: {
+					xtype: 'container',
+					layout: 'form',
+					defaults: {
+						labelWidth: 150
+					}
+				},
+				listeners: {
+					tabchange: {
+						fn: this.syncHeight,
+						scope: this
+					}
+				},
+				items: tabItems
+			},
+			buttons: [
+				this.buildButtonConfig('Cancel', this.onCancel),
+				this.buildButtonConfig('OK', handler)
+			]
+		});
+		this.show();
+	},
+	/*
 	 * Insert the table or update the table properties and close the dialogue
 	 */
-	tablePropertiesUpdate : function(dialog, params) {
+	tablePropertiesUpdate: function () {
+		this.restoreSelection()
+		var params = {};
+		var fieldTypes = ['combo', 'textfield', 'numberfield', 'checkbox', 'colorpalettefield'];
+		this.dialog.findBy(function (item) {
+			if (fieldTypes.indexOf(item.getXType()) !== -1) {
+				params[item.getItemId()] = item.getValue();
+				return true;
+			}
+			return false;
+		});
+		var errorFlag = false;
 		if (this.buttonsConfiguration.table.properties && this.buttonsConfiguration.table.properties.required) {
-			if (this.buttonsConfiguration.table.properties.required.indexOf("captionOrSummary") != -1) {
+			if (this.buttonsConfiguration.table.properties.required.indexOf('captionOrSummary') != -1) {
 				if (!/\S/.test(params.f_caption) && !/\S/.test(params.f_summary)) {
-					dialog.dialogWindow.alert(this.localize("captionOrSummary" + "-required"));
-					var el = dialog.document.getElementById("f_caption");
-					el.focus();
+					Ext.MessageBox.alert(this.localize('Error'), this.localize('captionOrSummary' + '-required'));
+					var field = this.dialog.find('itemId', 'f_caption')[0];
+					var tab = field.findParentByType('container');
+					tab.ownerCt.activate(tab);
+					field.focus();
 					return false;
 				}
 			} else {
-				var required = { "f_caption": "caption", "f_summary": "summary" };
-				for (var i in required) {
-					if (required.hasOwnProperty(i)) {
-						var el = dialog.document.getElementById(i);
-						if (!el.value && this.buttonsConfiguration.table.properties.required.indexOf(required[i]) != -1) {
-							dialog.dialogWindow.alert(this.localize(required[i] + "-required"));
-							el.focus();
-							return false;
-						}
+				var required = {
+					f_caption: 'caption',
+					f_summary: 'summary'
+				};
+				Ext.iterate(required, function (item) {
+					if (!params[item] && this.buttonsConfiguration.table.properties.required.indexOf(required[item]) != -1) {
+						Ext.MessageBox.alert(this.localize('Error'), this.localize(required[item] + '-required'));
+						var field = this.dialog.find('itemId', item)[0];
+						var tab = field.findParentByType('container');
+						tab.ownerCt.activate(tab);
+						field.focus();
+						errorFlag = true;
+						return false;
 					}
+				}, this);
+				if (errorFlag) {
+					return false;
 				}
 			}
 		}
-		var doc = dialog.editor._doc;
-		if (dialog.buttonId === "InsertTable") {
-			var required = { "f_rows": "You must enter a number of rows", "f_cols": "You must enter a number of columns" };
-			for (var i in required) {
-				if (required.hasOwnProperty(i)) {
-					var el = dialog.document.getElementById(i);
-					if (!el.value) {
-						dialog.dialogWindow.alert(this.localize(required[i]));
-						el.focus();
-						return false;
-					}
+		var doc = this.editor._doc;
+		if (this.dialog.arguments.buttonId === 'InsertTable') {
+			var required = {
+				f_rows: 'You must enter a number of rows',
+				f_cols: 'You must enter a number of columns'
+			};
+			Ext.iterate(required, function (item) {
+				if (!params[item]) {
+					Ext.MessageBox.alert(this.localize('Error'), this.localize(required[item]));
+					var field = this.dialog.find('itemId', item)[0];
+					var tab = field.findParentByType('container');
+					tab.ownerCt.activate(tab);
+					field.focus();
+					errorFlag = true;
+					return false;
 				}
+			}, this);
+			if (errorFlag) {
+				return false;
 			}
-			var table = doc.createElement("table");
-			var tbody = doc.createElement("tbody");
+			var table = doc.createElement('table');
+			var tbody = doc.createElement('tbody');
 			table.appendChild(tbody);
 			for (var i = params.f_rows; --i >= 0;) {
-				var tr = doc.createElement("tr");
+				var tr = doc.createElement('tr');
 				tbody.appendChild(tr);
 				for (var j = params.f_cols; --j >= 0;) {
-					var td = doc.createElement("td");
-					if (HTMLArea.is_gecko) td.innerHTML = "<br />";
+					var td = doc.createElement('td');
+					if (HTMLArea.is_gecko) td.innerHTML = '<br />';
 					tr.appendChild(td);
 				}
 			}
 		} else {
-			var table = dialog.arguments.element;
+			var table = this.dialog.arguments.element;
 		}
-		table = this.setHeaders(table, params);
-		table = this.processStyle(table, params);
-		table.removeAttribute("border");
-		for (var i in params) {
-			if (params.hasOwnProperty(i)) {
-				var val = params[i];
-				switch (i) {
-				    case "f_caption":
-					if (/\S/.test(val)) {
-						// contains non white-space characters
-						var caption = table.getElementsByTagName("caption");
-						if (caption) {
-							caption = caption[0];
-						}
-						if (!caption) {
-							var caption = doc.createElement("caption");
-							table.insertBefore(caption, table.firstChild);
-						}
-						caption.innerHTML = val;
-					} else {
-						// delete the caption if found
-						if (table.caption) table.deleteCaption();
+		this.setHeaders(table, params);
+		this.processStyle(table, params);
+		table.removeAttribute('border');
+		Ext.iterate(params, function (item) {
+			var val = params[item];
+			switch (item) {
+			    case "f_caption":
+				if (/\S/.test(val)) {
+					// contains non white-space characters
+					var caption = table.getElementsByTagName("caption");
+					if (caption) {
+						caption = caption[0];
 					}
-					break;
-				    case "f_summary":
-					table.summary = val;
-					break;
-				    case "f_width":
-					table.style.width = ("" + val) + params.f_unit;
-					break;
-				    case "f_align":
-					table.align = val;
-					break;
-				    case "f_spacing":
-					table.cellSpacing = val;
-					break;
-				    case "f_padding":
-					table.cellPadding = val;
-					break;
-				    case "f_frames":
-					table.frame = (val != "not set") ? val : "";
-					break;
-				    case "f_rules":
-					if (val != "not set") table.rules = val;
-						else table.removeAttribute("rules");
-					break;
-				    case "f_st_float":
-					switch (val) {
-					    case "not set":
-						HTMLArea._removeClass(table, this.floatRight);
-						HTMLArea._removeClass(table, this.floatLeft);
-						break;
-					    case "right":
-						HTMLArea._removeClass(table, this.floatLeft);
-						HTMLArea._addClass(table, this.floatRight);
-						break;
-					    case "left":
-						HTMLArea._removeClass(table, this.floatRight);
-						HTMLArea._addClass(table, this.floatLeft);
-						break;
+					if (!caption) {
+						var caption = doc.createElement("caption");
+						table.insertBefore(caption, table.firstChild);
 					}
+					caption.innerHTML = val;
+				} else {
+					// delete the caption if found
+					if (table.caption) table.deleteCaption();
+				}
+				break;
+			    case "f_summary":
+				table.summary = val;
+				break;
+			    case "f_width":
+				table.style.width = ("" + val) + params.f_unit;
+				break;
+			    case "f_align":
+				table.align = val;
+				break;
+			    case "f_spacing":
+				table.cellSpacing = val;
+				break;
+			    case "f_padding":
+				table.cellPadding = val;
+				break;
+			    case "f_frames":
+			    	    if (val !== 'not set' && table.style.borderStyle !== 'none') {
+			    	    	    table.frame = val;
+			    	    } else {
+			    	    	    table.removeAttribute('rules');
+			    	    }
+				break;
+			    case "f_rules":
+			    	    if (val !== 'not set') {
+			    	    	    table.rules = val;
+			    	    } else {
+			    	    	    table.removeAttribute('rules');
+			    	    }
+				break;
+			    case "f_st_float":
+				switch (val) {
+				    case "not set":
+					HTMLArea._removeClass(table, this.floatRight);
+					HTMLArea._removeClass(table, this.floatLeft);
 					break;
-				    case "f_st_textAlign":
-					if (this.editor.plugins.BlockElements) {
-						this.editor.plugins.BlockElements.instance.toggleAlignmentClass(table, this.convertAlignment[val]);
-						table.style.textAlign = "";
-					}
+				    case "right":
+					HTMLArea._removeClass(table, this.floatLeft);
+					HTMLArea._addClass(table, this.floatRight);
 					break;
-				    case "f_class":
-				    case "f_class_tbody":
-				    case "f_class_thead":
-				    case "f_class_tfoot":
-					var tpart = table;
-					if (i.length > 7) tpart = table.getElementsByTagName(i.substring(8,13))[0];
-					if (tpart) {
-						this.editor.plugins.BlockStyle.instance.applyClassChange(tpart, val);
-					}
+				    case "left":
+					HTMLArea._removeClass(table, this.floatRight);
+					HTMLArea._addClass(table, this.floatLeft);
 					break;
-				    case "f_lang":
-					this.getPluginInstance("Language").setLanguageAttributes(table, val);
-					break;
-				    case "f_dir":
-					table.dir = (val != "not set") ? val : "";
-					break;
 				}
+				break;
+			    case "f_st_textAlign":
+				if (this.getPluginInstance('BlockElements')) {
+					this.getPluginInstance('BlockElements').toggleAlignmentClass(table, this.convertAlignment[val]);
+					table.style.textAlign = "";
+				}
+				break;
+			    case "f_class":
+			    case "f_class_tbody":
+			    case "f_class_thead":
+			    case "f_class_tfoot":
+				var tpart = table;
+				if (item.length > 7) {
+					tpart = table.getElementsByTagName(item.substring(8,13))[0];
+				}
+				if (tpart) {
+					this.getPluginInstance('BlockStyle').applyClassChange(tpart, val);
+				}
+				break;
+			    case "f_lang":
+				this.getPluginInstance('Language').setLanguageAttributes(table, val);
+				break;
+			    case "f_dir":
+				table.dir = (val != "not set") ? val : "";
+				break;
 			}
-		}
-		if (dialog.buttonId === "InsertTable") {
-			if (HTMLArea.is_gecko) {
+		}, this);
+		if (this.dialog.arguments.buttonId === "InsertTable") {
+			if (!Ext.isIE) {
 				this.editor.insertNodeAtSelection(table);
 			} else {
 				table.id = "htmlarea_table_insert";
@@ -364,94 +570,38 @@
 				this.toggleBorders(true);
 			}
 		}
-		dialog.close();
+		this.close();
 	},
-	
 	/*
-	 * Open the row/column/cell properties dialogue
+	 * Update the row/column/cell properties
 	 */
-	dialogRowCellProperties : function (cell, column) {
-			// retrieve existing values
-		if (cell) {
-			var element = this.getClosest("td");
-			if (!element) var element = this.getClosest("th");
-		} else {
-			var element = this.getClosest("tr");
-		}
-		if (element) {
-			var rowCellPropertiesInitFunctRef = this.makeFunctionReference("rowCellPropertiesInit");
-			var arguments = {
-				title 		: (cell ? (column ? "Column Properties" : "Cell Properties") : "Row Properties"),
-				initialize	: rowCellPropertiesInitFunctRef,
-				element		: element,
-				cell		: cell,
-				column		: column
-			};
-			this.dialog = this.openDialog("TO-" + (cell ? (column ? "col-prop" : "cell-prop") :"row-prop"), "", "rowCellPropertiesUpdate", arguments, { width : 660, height : 460 });
-		}
-	},
-	
-	/*
-	 * Initialize the row/column/cell properties dialogue
-	 */
-	rowCellPropertiesInit : function(dialog) {
-		var doc = dialog.document;
-		var content = dialog.content;
-		var element = dialog.arguments.element;
-		var cell = dialog.arguments.cell;
-		var column = dialog.arguments.column;
-		this.removedFieldsets = this.buttonsConfiguration[cell?(column?"columnproperties":"cellproperties"):"rowproperties"].removeFieldsets ? this.buttonsConfiguration[cell?(column?"columnproperties":"cellproperties"):"rowproperties"].removeFieldsets : "";
-		this.properties = this.buttonsConfiguration[(cell ||column)?"cellproperties":"rowproperties"].properties;
-		this.removedProperties = (this.properties && this.properties.removed) ? this.properties.removed : "";
-		TableOperations.buildTitle(doc, content, (cell ? (column ? "Column Properties" : "Cell Properties") : "Row Properties"));
-		TableOperations.insertSpace(doc, content);
-		if (column) {
-			if (this.removedFieldsets.indexOf("columntype") == -1) this.buildCellTypeFieldset(doc, element, content, true);
-		} else if (cell) {
-			if (this.removedFieldsets.indexOf("celltype") == -1) this.buildCellTypeFieldset(doc, element, content, false);
-		} else {
-			if (this.removedFieldsets.indexOf("rowgroup") == -1) TableOperations.buildRowGroupFieldset(dialog.dialogWindow, doc, dialog.editor, element, content);
-		}
-		if (this.removedFieldsets.indexOf("style") == -1 && this.editor.config.customSelects.BlockStyle) {
-			var blockStyle = this.editor.plugins.BlockStyle.instance;
-			if (blockStyle && blockStyle.cssLoaded) {
-				this.buildStylingFieldset(doc, element, content);
-				TableOperations.insertSpace(doc, content);
-			} else {
-				TableOperations.insertSpace(doc, content);
+	rowCellPropertiesUpdate: function() {
+		this.restoreSelection()
+			// Collect values from each form field
+		var params = {};
+		var fieldTypes = ['combo', 'textfield', 'numberfield', 'checkbox', 'colorpalettefield'];
+		this.dialog.findBy(function (item) {
+			if (fieldTypes.indexOf(item.getXType()) !== -1) {
+				params[item.getItemId()] = item.getValue();
+				return true;
 			}
-		} else {
-			TableOperations.insertSpace(doc, content);
-		}
-		this.buildLanguageFieldset(doc, element, content, "floating");
-		if (this.removedFieldsets.indexOf("layout") == -1) this.buildLayoutFieldset(doc, element, content, "floating");
-		if (this.removedFieldsets.indexOf("alignment") == -1) this.buildAlignmentFieldset(doc, element, content);
-		if (this.removedFieldsets.indexOf("borders") == -1) this.buildBordersFieldset(dialog.dialogWindow, doc, dialog.editor, element, content);
-		if (this.removedFieldsets.indexOf("color") == -1) TableOperations.buildColorsFieldset(dialog.dialogWindow, doc, dialog.editor, element, content);
-		dialog.addButtons("ok", "cancel");
-	},
-	
-	/*
-	 * Update the row/column/cell properties
-	 */
-	rowCellPropertiesUpdate : function(dialog, params) {
-		var element = dialog.arguments.element;
-		var cell = dialog.arguments.cell;
-		var column = dialog.arguments.column;
-		var section = (cell || column) ? element.parentNode.parentNode : element.parentNode;
+			return false;
+		});
+		var cell = this.dialog.arguments.cell;
+		var column = this.dialog.arguments.column;
+		var section = (cell || column) ? this.dialog.arguments.element.parentNode.parentNode : this.dialog.arguments.element.parentNode;
 		var table = section.parentNode;
-		var elements = new Array();
+		var elements = [];
 		if (column) {
-			elements = this.getColumnCells(dialog.arguments.element);
+			elements = this.getColumnCells(this.dialog.arguments.element);
 		} else {
-			elements.push(dialog.arguments.element);
+			elements.push(this.dialog.arguments.element);
 		}
-		for (var k = elements.length; --k >= 0;) {
-			var element = elements[k];
-			element = this.processStyle(element, params);
-			for (var i in params) {
-				var val = params[i];
-				switch (i) {
+		Ext.each(elements, function (element) {
+			this.processStyle(element, params);
+			Ext.iterate(params, function (item) {
+				var val = params[item];
+				switch (item) {
 				    case "f_cell_type":
 					if (val.substring(0,2) != element.nodeName.toLowerCase()) {
 						element = this.remapCell(element, val.substring(0,2));
@@ -465,7 +615,7 @@
 					var nodeName = section.nodeName.toLowerCase();
 					if (val != nodeName) {
 						var newSection = table.getElementsByTagName(val)[0];
-						if (!newSection) var newSection = table.insertBefore(dialog.editor._doc.createElement(val), table.getElementsByTagName("tbody")[0]);
+						if (!newSection) var newSection = table.insertBefore(this.editor._doc.createElement(val), table.getElementsByTagName("tbody")[0]);
 						if (nodeName == "thead" && val == "tbody") var newElement = newSection.insertBefore(element, newSection.firstChild);
 							else var newElement = newSection.appendChild(element);
 						if (!section.hasChildNodes()) table.removeChild(section);
@@ -479,46 +629,52 @@
 					}
 					break;
 				    case "f_st_textAlign":
-					if (this.editor.plugins.BlockElements) {
-						this.editor.plugins.BlockElements.instance.toggleAlignmentClass(element, this.convertAlignment[val]);
+					if (this.getPluginInstance('BlockElements')) {
+						this.getPluginInstance('BlockElements').toggleAlignmentClass(element, this.convertAlignment[val]);
 						element.style.textAlign = "";
 					}
 					break;
 				    case "f_class":
-					this.editor.plugins.BlockStyle.instance.applyClassChange(element, val);
+					this.getPluginInstance('BlockStyle').applyClassChange(element, val);
 					break;
 				    case "f_lang":
-					this.getPluginInstance("Language").setLanguageAttributes(element, val);
+					this.getPluginInstance('Language').setLanguageAttributes(element, val);
 					break;
 				    case "f_dir":
 					element.dir = (val != "not set") ? val : "";
 					break;
 				}
-			}
-		}
+			}, this);
+		}, this);
 		this.reStyleTable(table);
-		dialog.close();
+		this.close();
 	},
-	
 	/*
 	 * This function gets called when the plugin is generated
-	 * Set table borders if requested by configuration
 	 */
-	onGenerate : function() {
+	onGenerate: function () {
+			// Set table borders if requested by configuration
 		if (this.buttonsConfiguration.toggleborders && this.buttonsConfiguration.toggleborders.setOnRTEOpen) {
 			this.toggleBorders(true);
 		}
+			// Register handler for the enter key for IE and Opera when buttons.table.disableEnterParagraphs is set in the editor configuration
+		if ((Ext.isIE || Ext.isOpera) && this.disableEnterParagraphs) {
+			this.editor.iframe.keyMap.addBinding({
+				key: Ext.EventObject.ENTER,
+				shift: false,
+				handler: this.onKey,
+				scope: this
+			});
+		}
 	},
-	
 	/*
 	 * This function gets called when the toolbar is being updated
 	 */
-	onUpdateToolbar : function() {
-		if (this.getEditorMode() === "wysiwyg" && this.editor.isEditable() && this.isButtonInToolbar("TO-toggle-borders")) {
-			this.editor._toolbarObjects["TO-toggle-borders"].state("active", HTMLArea._hasClass(this.editor._doc.body, 'htmlarea-showtableborders'));
+	onUpdateToolbar: function (button, mode, selectionEmpty, ancestors) {
+		if (mode === 'wysiwyg' && this.editor.isEditable() && button.itemId === 'TO-toggle-borders') {
+			button.setInactive(!HTMLArea._hasClass(this.editor._doc.body, 'htmlarea-showtableborders'));
 		}
 	},
-	
 	/*
 	 * This function gets called when a Table Operations button was pressed.
 	 *
@@ -527,7 +683,7 @@
 	 *
 	 * @return	boolean		false if action is completed
 	 */
-	onButtonPress : function (editor, id, target) {
+	onButtonPress: function (editor, id, target) {
 			// Could be a button or its hotkey
 		var buttonId = this.translateHotKey(id);
 		buttonId = buttonId ? buttonId : id;
